unit Unit1;

{
Exemple d'utilisation des mthodes BeginUpdate et EndUpdate
--
DEBOVE Benjamin
29/07/2004
}

{------------------------------------------------------------------------------}
                                   INTERFACE                                    
{------------------------------------------------------------------------------}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Util_Curseur, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    Memo1: TMemo;
    PanelBottom: TPanel;
    LabelSecondes: TLabel;
    LabelSecondeEcoule: TLabel;
    LabelIterations: TLabel;
    GroupBoxAvecUpdate: TGroupBox;
    ButtonChargerAvecUpdate: TButton;
    ButtonViderAvecUpdate: TButton;
    GroupBoxSansUpdate: TGroupBox;
    ButtonViderSansUpdate: TButton;
    ButtonChargerSansUpdate: TButton;
    SpinEditIteration: TSpinEdit;
    procedure ButtonChargerSansUpdateClick(Sender: TObject);
    procedure ButtonChargerAvecUpdateClick(Sender: TObject);
    procedure ButtonViderSansUpdateClick(Sender: TObject);
    procedure ButtonViderAvecUpdateClick(Sender: TObject);
    procedure LabeledEditIterationsKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure LabeledEditSecondesKeyPress(Sender: TObject; var Key: Char);
  private
    procedure NotifyStopWait(Const TempsEcoule : cardinal);
  public
  end;

var
  Form1: TForm1;

{------------------------------------------------------------------------------}
                                 IMPLEMENTATION
{------------------------------------------------------------------------------}
{$R *.dfm}
{---------------------------------FORM-CREATE----------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Util_Curseur.OnStopWait := NotifyStopWait;
end;
{-------------------------------NOTIFY-STOP-WAIT-------------------------------}
procedure TForm1.NotifyStopWait(const TempsEcoule: cardinal);
begin
  LabelSecondes.Caption := FloatToStr(TempsEcoule/1000);
end;
{-----------------------BUTTON-CHARGER-SANS-UPDATE-CLICK-----------------------}
procedure TForm1.ButtonChargerSansUpdateClick(Sender: TObject);
var i : integer;
begin       
  StartWait;
  for i := 0 to StrToInt(SpinEditIteration.Text) do TreeView1.Items.Add(nil, IntToStr(i));
  StopWait;
end;
{------------------------BUTTON-VIDER-SANS-UPDATE-CLICK------------------------}
procedure TForm1.ButtonViderSansUpdateClick(Sender: TObject);
begin
  StartWait;
  TreeView1.Items.Clear;
  StopWait;
end;
{-----------------------BUTTON-CHARGER-AVEC-UPDATE-CLICK-----------------------}
procedure TForm1.ButtonChargerAvecUpdateClick(Sender: TObject);
begin
  TreeView1.Items.BeginUpdate;
  ButtonChargerSansUpdateClick(nil);
  TreeView1.Items.EndUpdate;
end;
{------------------------BUTTON-VIDER-AVEC-UPDATE-CLICK------------------------}
procedure TForm1.ButtonViderAvecUpdateClick(Sender: TObject);
begin
  TreeView1.Items.BeginUpdate;
  ButtonViderSansUpdateClick(nil);
  TreeView1.Items.EndUpdate;
end;
{----------------------LABELED-EDIT-ITERATIONS-KEY-PRESS-----------------------}
procedure TForm1.LabeledEditIterationsKeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in [#8,'0'..'9']) then key:=#0;
end;
{-----------------------LABELED-EDIT-SECONDES-KEY-PRESS------------------------}
procedure TForm1.LabeledEditSecondesKeyPress(Sender: TObject; var Key: Char);
begin
  key:=#0;
end;

end.
